import { __AdaptedExports, instantiate } from './release'

import * as path from 'node:path'
import * as fs from 'node:fs/promises'

export async function InitWasm(): Promise<typeof __AdaptedExports> {
    return new Promise(async resolve => {
        const wasmFilePath = path.resolve(__dirname, 'release.wasm')

        const wasm: typeof __AdaptedExports = await instantiate(
            await (async () => {
                return globalThis.WebAssembly.compile(
                    await fs.readFile(wasmFilePath),
                )
            })(),
            { env: '' },
        )

        resolve(wasm)
    })
}
